#include "Color.h"

Color::Color(unsigned char r, unsigned char g, unsigned char b, double a)
    : mR(r),
      mG(g),
      mB(b),
      mAlpha(a)
{

}

std::unique_ptr<Color> Color::Create(unsigned char r, unsigned char g, unsigned char b, double a )
{
    return std::make_unique<Color>(r, g, b, a);
}

std::unique_ptr<Color> Color::Create(const Color& color)
{
    return std::make_unique<Color>(color);
}

unsigned char Color::getR() const
{
    return mR;
}

unsigned char Color::getG() const
{
    return mG;
}

unsigned char Color::getB() const
{
    return mB;
}

double Color::getAlpha() const
{
    return mAlpha;
}

std::vector<double> Color::getAsVectorDouble() const
{
    return { mR / 255.0, mG / 255.0, mB / 255.0, mAlpha };
}

uint32_t Color::getAsUInt32() const
{
    return static_cast<uint32_t>(mB + (mG << 8) + (mR << 16));
}